`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA02) - 3. labor                                   *
//*                                                                            *
//* 1. feladat: 2/1 s 4/1 multiplexerek.                                      *
//******************************************************************************
module multiplexers(
   //A 2/1 multiplexer portjai.
   input  wire [1:0] mux1_in,       //Bemenetek.
   input  wire       mux1_sel,      //Kivlaszt jel.
   output wire       mux1_out,      //Kimenet.
   
   //A 4/1 multiplexer portjai.
   input  wire [3:0] mux2_in,       //Bemenetek.
   input  wire [1:0] mux2_sel,      //Kivlaszt jel.
   output reg        mux2_out       //Kimenet.
);

//Valstsuk meg a 2/1 multiplexert feltteles opertor hasznlatval.
//A multiplexer a kivlaszt jel rtknek megfelel sorszm bemeneti
//bitet tegye ki a kimenetre.
assign mux1_out = (mux1_sel) ? mux1_in[1] : mux1_in[0];

//Valstsuk meg a 4/1 multiplexert always blokk s case utasts
//hasznlatval. A multiplexer a kivlaszt jel rtknek megfelel
//sorszm bemeneti bitet tegye ki a kimenetre.
always @(*)
begin
   case (mux2_sel)
      2'b01  : mux2_out <= mux2_in[1];
      2'b10  : mux2_out <= mux2_in[2];
      2'b11  : mux2_out <= mux2_in[3];
      default: mux2_out <= mux2_in[0];
   endcase
end

endmodule
